package org.bitbucket.bradleysmithllc.etlunit.feature.informatica;

import org.bitbucket.bradleysmithllc.etlunit.feature.informatica.util.InformaticaIntegrationServiceClient;

public class InformaticaIntegrationService
{
	private final String name;
	private final InformaticaDomain informaticaDomain;
	private final InformaticaFeatureModule informaticaFeatureModule;

	private InformaticaIntegrationServiceClient informaticaIntegrationServiceClient;

	public InformaticaIntegrationService(InformaticaDomain domain, String name, InformaticaFeatureModule module)
	{
		this.name = name;
		informaticaDomain = domain;
		informaticaFeatureModule = module;
	}

	public String getIntegrationServiceName()
	{
		return name;
	}

	public InformaticaDomain getInformaticaDomain()
	{
		return informaticaDomain;
	}

	public InformaticaIntegrationServiceClient getInformaticaIntegrationServiceClient() throws Exception
	{
		if (informaticaIntegrationServiceClient == null)
		{
			informaticaIntegrationServiceClient = informaticaFeatureModule.getIntegrationServiceClient(this);
		}

		return informaticaIntegrationServiceClient;
	}

	public void dispose()
	{
		if (informaticaIntegrationServiceClient != null)
		{
			informaticaIntegrationServiceClient.dispose();
		}
	}
}
