package org.bitbucket.bradleysmithllc.etlunit.feature.informatica.util;

import org.bitbucket.bradleysmithllc.etlunit.InformaticaError;
import org.bitbucket.bradleysmithllc.etlunit.feature.informatica.InformaticaIntegrationService;
import org.bitbucket.bradleysmithllc.etlunit.feature.informatica.InformaticaRepository;

import java.io.File;
import java.util.List;

public interface InformaticaRepositoryClient extends InformaticaClient
{
	void createConnection(
		String serverName,
		String databaseName,
		String databaseUsername,
		String databasePassword,
		String relationalConnectionName
	) throws Exception, InformaticaError;

	void createFolder(String folder) throws Exception, InformaticaError;
	void createFolder(String folder, boolean temporary) throws Exception, InformaticaError;
	void deleteFolder(String folder) throws Exception, InformaticaError;
	void deleteFolder(String folder, boolean failIfNotExists) throws Exception, InformaticaError;

	void deleteConnection(
		String connectionName
	) throws Exception, InformaticaError;

	void deleteConnection(
			String connectionName,
			boolean failIfNotExists
	) throws Exception, InformaticaError;


	void deleteTemporaryFolders() throws Exception, InformaticaError;

	void exportWorkflowToXml(
		String workFlow,
		String folder,
		File output
	) throws Exception, InformaticaError;

	void exportAllWorkflowsToXml() throws Exception, InformaticaError;

	void importWorkflowFromXml(
		String folderPrefix,
		InformaticaIntegrationService newService,
		File xmlFile,
		List<String> flist
	) throws Exception;

	void importWorkflowFromXml(
		String folderPrefix,
		InformaticaIntegrationService newService,
		File xml
	) throws Exception;

	List<String> listFolders() throws Exception, InformaticaError;

	void purgeTestFolders() throws Exception, InformaticaError;

	InformaticaRepository getInformaticaRepository();
}